VERSION 5.00
Begin VB.Form frmDevList 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "  Showing known device IDs according to DLL and the System Registry"
   ClientHeight    =   1770
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   9660
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1770
   ScaleWidth      =   9660
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnClose 
      BackColor       =   &H00C0C0FF&
      Caption         =   "Close"
      Height          =   495
      Left            =   8790
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   1140
      Width           =   705
   End
   Begin VB.CommandButton btnRefresh 
      BackColor       =   &H00FFC0C0&
      Caption         =   "Refresh Now"
      Height          =   495
      Left            =   7920
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   1140
      Width           =   855
   End
   Begin VB.TextBox Text2 
      Height          =   555
      Left            =   7890
      Locked          =   -1  'True
      TabIndex        =   9
      Top             =   1110
      Width           =   1635
   End
   Begin VB.CheckBox Check3 
      Alignment       =   1  'Right Justify
      Caption         =   "Show device ownership (which app owns what)"
      Height          =   255
      Left            =   3690
      TabIndex        =   7
      Top             =   1080
      Width           =   3825
   End
   Begin VB.ComboBox comboTimerInterval 
      Height          =   315
      ItemData        =   "frmList.frx":0000
      Left            =   5640
      List            =   "frmList.frx":001F
      TabIndex        =   6
      Text            =   "5"
      Top             =   1350
      Width           =   615
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   150
      Top             =   510
   End
   Begin VB.CheckBox chkRefreshConstant 
      Alignment       =   1  'Right Justify
      Caption         =   "Keep this refreshed every                 seconds"
      Height          =   225
      Left            =   3720
      TabIndex        =   5
      Top             =   1380
      Value           =   1  'Checked
      Width           =   3795
   End
   Begin VB.CheckBox Check2 
      Alignment       =   1  'Right Justify
      Caption         =   "Show only devices belonging to this app"
      Height          =   255
      Left            =   90
      TabIndex        =   4
      Top             =   1380
      Width           =   3165
   End
   Begin VB.CheckBox Check1 
      Alignment       =   1  'Right Justify
      Caption         =   "Show all devices -- even if disconnected"
      Height          =   225
      Left            =   90
      TabIndex        =   2
      Top             =   1110
      Value           =   1  'Checked
      Width           =   3165
   End
   Begin VB.TextBox txtDevList 
      Height          =   885
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   90
      Width           =   9495
   End
   Begin VB.TextBox Text1 
      BackColor       =   &H8000000F&
      Height          =   645
      Left            =   30
      Locked          =   -1  'True
      TabIndex        =   8
      Top             =   1050
      Width           =   9525
   End
End
Attribute VB_Name = "frmDevList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Version 2.04.2008
' Last updated: 2-21-2008

Option Explicit

Private Sub btnClose_Click()
    frmDevList.Hide
End Sub
Private Sub btnRefresh_Click()
    If chkRefreshConstant.Value = vbChecked Then
        Timer1.Enabled = False
    End If

    Dim bIndex As Byte
    Dim usDevList(32) As Integer
    Dim LAppHandleList(32) As Long
    Dim uiUnused As Long
    Dim bDevListIndex As Byte
    Dim bThisRetVal As Byte
    Dim fDevFoundInList As Boolean: fDevFoundInList = False
    For bDevListIndex = 0 To 31
        usDevList(bDevListIndex) = 0
    Next bDevListIndex

    frmDevList.txtDevList = ""
    
    If frmDevList.Check3.Value = vbChecked Then
        bThisRetVal = SP_GetDevOwnershipList(usDevList(0), LAppHandleList(0))
        frmDevList.txtDevList = "showing deviced ownership of ALL devices " & _
            "using Application HANDLE (in HEX). " _
            & "This app's HANDLE: " & Hex(frmLL_USB.hwnd) & vbCrLf & vbCrLf
        If bThisRetVal Then
            For bIndex = 0 To 31
                If usDevList(bIndex) <> 0 Then
                    frmDevList.txtDevList = frmDevList.txtDevList & usDevList(bIndex) & " {"
                    frmDevList.txtDevList = frmDevList.txtDevList & Hex(LAppHandleList(bIndex)) & "}, "
                End If
            Next bIndex
        End If
    ElseIf frmDevList.Check2.Value = vbChecked Then
        bThisRetVal = SP_GetAppDevList(usDevList(0), uiUnused)
        frmDevList.txtDevList = "showing only devices assigned to  THIS APP.   " & _
            "HANDLE: " & Hex(frmLL_USB.hwnd) & vbCrLf & vbCrLf
        If bThisRetVal Then
            For bIndex = 0 To 31
                If usDevList(bIndex) <> 0 Then
                    frmDevList.txtDevList = frmDevList.txtDevList & usDevList(bIndex) & ", "
                End If
            Next bIndex
        End If
    ElseIf frmDevList.Check1.Value = vbChecked Then
        bThisRetVal = SP_GetRegDevList(usDevList(0), uiUnused)
        If frmDevList.Check1.Value = vbUnchecked Then
            frmDevList.txtDevList = "showing all  CONNECTED  devices according to registry :" _
            & vbCrLf & vbCrLf
        Else
            frmDevList.txtDevList = "Showing  ALL  devices according to registry.   " _
            & "Those preceded by  x_  are disconnected :" & vbCrLf & vbCrLf
        End If
        
        If bThisRetVal Then
            For bIndex = 0 To 31
                If usDevList(bIndex) <> 0 Then
                    If (usDevList(bIndex) And &H8000) = &H8000 Then
                        If frmDevList.Check1.Value = vbChecked Then
                            frmDevList.txtDevList = frmDevList.txtDevList & "x_" & (usDevList(bIndex) And &H7FFF) & ", "
                        End If
                    Else
                        frmDevList.txtDevList = frmDevList.txtDevList & usDevList(bIndex) & ", "
                    End If
                    
                End If
            Next bIndex
        End If
    End If
    If chkRefreshConstant.Value = vbChecked Then
        Timer1.Enabled = True
    End If

End Sub
Private Sub Check1_Click()
    If Check1.Value = vbChecked Then
        frmDevList.Caption = " All Devices In Registry"
        If Check2.Value = vbChecked Then
            Check2.Value = vbUnchecked
        End If
        If Check3.Value = vbChecked Then
            Check3.Value = vbUnchecked
        End If
        btnRefresh_Click
    Else
        frmDevList.Caption = " Only connected devices"
    End If
End Sub
Private Sub Check2_Click()
    If Check2.Value = vbChecked Then
        frmDevList.Caption = " Only this app's devices"
        If Check1.Value = vbChecked Then
            Check1.Value = vbUnchecked
        End If
        If Check3.Value = vbChecked Then
            Check3.Value = vbUnchecked
        End If
        btnRefresh_Click
    End If
End Sub
Private Sub Check3_Click()
    If Check3.Value = vbChecked Then
        If Check1.Value = vbChecked Then
            Check1.Value = vbUnchecked
        End If
        If Check2.Value = vbChecked Then
            Check2.Value = vbUnchecked
        End If
        frmDevList.Caption = " Device ID ownership HANDLE"
        btnRefresh_Click
    End If
End Sub

Private Sub chkRefreshConstant_Click()
    If chkRefreshConstant.Value = vbChecked Then
        Timer1.Enabled = True
    Else
        Timer1.Enabled = False
    End If
End Sub
Private Sub comboTimerInterval_Click()
    Dim LVal As Long
    LVal = comboTimerInterval.Text
    If LVal <> 0 Then
        LVal = LVal * 1000
        Timer1.Interval = LVal
        Timer1.Enabled = True
    Else
        Timer1.Enabled = False
    End If
End Sub
Private Sub Form_Activate()
    frmDevList.Top = 2
    frmDevList.Left = 2
    Dim LVal As Long
    LVal = comboTimerInterval.Text
    LVal = LVal * 1000
    Timer1.Interval = LVal
End Sub
Private Sub Timer1_Timer()
    If frmDevList.Visible = True Then
        btnRefresh_Click
    End If
End Sub





