VERSION 5.00
Begin VB.Form frmSetup 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " P o l l e d    S e t u p"
   ClientHeight    =   2025
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4110
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   ScaleHeight     =   2025
   ScaleWidth      =   4110
   StartUpPosition =   1  'CenterOwner
   Begin VB.ComboBox ComboID 
      Enabled         =   0   'False
      Height          =   315
      Left            =   210
      TabIndex        =   13
      Top             =   330
      Width           =   675
   End
   Begin VB.CommandButton BtnCancel 
      Caption         =   "Cancel"
      Height          =   405
      Left            =   2430
      TabIndex        =   11
      Top             =   1440
      Width           =   1545
   End
   Begin VB.CheckBox ChkLogToFile 
      Caption         =   "Log to file"
      Height          =   195
      Left            =   2940
      TabIndex        =   10
      Top             =   1050
      Width           =   1005
   End
   Begin VB.Frame PnlActiveChannels 
      Caption         =   "Active channels"
      Height          =   525
      Left            =   180
      TabIndex        =   7
      Top             =   810
      Width           =   2385
      Begin VB.CheckBox ChkChan1 
         Caption         =   "Chan - 1"
         Height          =   255
         Left            =   1380
         TabIndex        =   9
         Top             =   210
         Width           =   945
      End
      Begin VB.CheckBox ChkChan0 
         Caption         =   "Chan - 0"
         Height          =   195
         Left            =   90
         TabIndex        =   8
         Top             =   240
         Width           =   1005
      End
   End
   Begin VB.CommandButton BtnSave 
      Caption         =   "S A V E"
      Height          =   405
      Left            =   180
      TabIndex        =   3
      Top             =   1440
      Width           =   1965
   End
   Begin VB.ComboBox ComboChan 
      Height          =   315
      ItemData        =   "frmSetup.frx":0000
      Left            =   1110
      List            =   "frmSetup.frx":0010
      TabIndex        =   0
      Text            =   "0"
      Top             =   330
      Width           =   555
   End
   Begin VB.ComboBox ComboRange 
      Height          =   315
      ItemData        =   "frmSetup.frx":0020
      Left            =   3030
      List            =   "frmSetup.frx":002A
      TabIndex        =   2
      Text            =   "Bipolar"
      Top             =   330
      Width           =   885
   End
   Begin VB.ComboBox ComboRate 
      Height          =   315
      ItemData        =   "frmSetup.frx":0041
      Left            =   1920
      List            =   "frmSetup.frx":005A
      TabIndex        =   1
      Text            =   "100Hz"
      Top             =   330
      Width           =   885
   End
   Begin VB.Shape Shape5 
      FillColor       =   &H0080C0FF&
      FillStyle       =   0  'Solid
      Height          =   375
      Left            =   180
      Top             =   300
      Width           =   765
   End
   Begin VB.Label lblDevID 
      Caption         =   "Dev. ID"
      Enabled         =   0   'False
      Height          =   195
      Left            =   180
      TabIndex        =   12
      Top             =   90
      Width           =   585
   End
   Begin VB.Shape Shape2 
      FillColor       =   &H000000C0&
      FillStyle       =   0  'Solid
      Height          =   465
      Left            =   2400
      Top             =   1410
      Width           =   1605
   End
   Begin VB.Label Label3 
      Caption         =   "Channel"
      Height          =   195
      Left            =   1050
      TabIndex        =   6
      Top             =   90
      Width           =   645
   End
   Begin VB.Shape Shape1 
      FillColor       =   &H0000C000&
      FillStyle       =   0  'Solid
      Height          =   465
      Left            =   150
      Top             =   1410
      Width           =   2025
   End
   Begin VB.Shape Shape8 
      FillColor       =   &H0080C0FF&
      FillStyle       =   0  'Solid
      Height          =   375
      Left            =   1050
      Top             =   300
      Width           =   675
   End
   Begin VB.Shape Shape3 
      FillColor       =   &H0080C0FF&
      FillStyle       =   0  'Solid
      Height          =   375
      Left            =   1860
      Top             =   300
      Width           =   1005
   End
   Begin VB.Label Label1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Rate "
      Height          =   225
      Left            =   1890
      TabIndex        =   5
      Top             =   90
      Width           =   705
   End
   Begin VB.Shape Shape4 
      FillColor       =   &H0080C0FF&
      FillStyle       =   0  'Solid
      Height          =   375
      Left            =   2970
      Top             =   300
      Width           =   1005
   End
   Begin VB.Label Label2 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Range"
      Height          =   225
      Left            =   2970
      TabIndex        =   4
      Top             =   90
      Width           =   495
   End
End
Attribute VB_Name = "frmSetup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Lawson Labs, Inc.
' 3217 Phoenixville Pike
' Malvern, PA  19355
' 800 321-5355 or 406 257-5355
' Last updated: 12-2-99
' programmer - Tim Van Dusen
' filename: frmSetup.frm
' Uses DLL: m301VB5.dll

Dim bDeviceNumChangePending As Byte
Dim bSetupFlags As Byte
Const NO_CHANGE = 0
Const RATE_CHANGE = 1
Const CHAN_CHANGE = 2
Const RANGE_CHANGE = 4
Const DEVICE_CHANGE = 8
Dim DeviceObjectArray_TEMP(64) As DEVICE_OBJECT
Dim bCurDevAsIndex_TEMP As Byte
Private Sub Form_Load()
    bSetupFlags = NO_CHANGE
    If bScreenMode = SCAN_SCREEN Then
        Caption = "S c a n    S e t u p"
        PnlActiveChannels.Visible = True
        ChkLogToFile.Visible = True
        ComboChan.Clear
        ComboChan.Text = 0
        ComboChan.AddItem (0)
        ComboChan.AddItem (1)
    Else
        Caption = "P o l l e d    S e t u p"
        ComboRate.Text = DeviceObjectArray(bCurDevAsIndex).DEV_iRate & "Hz"
        ComboChan.Text = DeviceObjectArray(bCurDevAsIndex).DEV_bChan
        PnlActiveChannels.Visible = False
        ChkLogToFile.Visible = False
    End If
    
    ComboID.Clear
    ComboID.Text = sLLABS_DeviceIDList(bCurDevAsIndex)
    If bNumDevicesLocal > 0 Then
        For i = 0 To bNumDevicesLocal - 1
            ComboID.AddItem (sLLABS_DeviceIDList(i))
        Next i
    End If
    
    If DeviceObjectArray(bCurDevAsIndex).DEV_bRange = 0 Then
        ComboRange.Text = "Unipolar"
    Else
        ComboRange.Text = "Bipolar"
    End If

    strSetupRateText = ComboRate.Text
    strSetupRangeText = ComboRange.Text
    strSetupComboDeviceNum = bCurDevAsIndex
    strSetupChanText = ComboChan.Text
    bCurDevAsIndex_TEMP = bCurDevAsIndex
    
    Dim bCurDev As Byte
    'For bCurDev = 0 To (bNumDevicesLocal - 1)
    '    frmSetup.ComboDeviceNum.List(bCurDev) = bCurDev
    '    frmSetup.ComboDeviceID.List(bCurDev) = Hex(DeviceObjectArray(bCurDev).DEV_sID)
    'Next bCurDev
    
    'frmSetup.ComboDeviceNum.Text = 0
    'frmSetup.ComboDeviceID.Text = Hex(DeviceObjectArray(0).DEV_sID) & "h"
    'ComboTest.Text = sDLLDebug
End Sub
Private Sub Form_Unload(Cancel As Integer)
    If bSetupFlags = 0 Then GoTo ENABLE_CONTROLS
    
    If bSetupFlags And RANGE_CHANGE Then
        strSetupRangeText = ComboRange.Text
        DeviceObjectArray(bCurDevAsIndex).DEV_bRange _
            = DeviceObjectArray_TEMP(bCurDevAsIndex).DEV_bRange
    End If
    
    frmSetup.Hide
'=======================================================
'=== Send rate for current device ======================
'=======================================================
    If fSignOn = False Then
        'MsgBox "Not signed on", MSG_BOX_OK
        'GoTo EXIT1
    End If
    
    If fSignOn Then
        MainPnlCtrlDisable
    
        If fAnyScanRunning = False Then
            If bSetupFlags And RATE_CHANGE Then
                iNumBytesToReadWrite = 8
                CalcAndLoadRateCodes
                
                frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
                    & "Sending rate for device: " & bCurDevAsIndex & vbCrLf
                fRetValMisc = ScrollText("down")
                
                fRetVal = DLL_ReadWriteOneDevice(DO_WRITE, bHostClientDataBuf(0), _
                        bCurDevAsIndex, iNumBytesToReadWrite, 0)
                If fRetVal = False Then
                    frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
                        & vbCrLf & "Device driver failed WRITE while sending rate" _
                        & vbCrLf & "Check all cable connections and try again." _
                        & vbCrLf
                    fRetValMisc = ScrollText("down")
                    GoTo ENABLE_CONTROLS
                End If
                frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
                    & "Rate sent for device: " & bCurDevAsIndex & vbCrLf
                fRetValMisc = ScrollText("down")
                
                
'=======================================================================
'=== Get results from sign-on ==========================================
'=======================================================================
                iNumBytesToReadWrite = 32
                ReDim bHostClientDataBuf(iNumBytesToReadWrite)
                
                fRetVal = DLL_ReadWriteOneDevice(DO_READ, bHostClientDataBuf(0), _
                        bCurDevAsIndex, iNumBytesToReadWrite, 0)
                If fRetVal = False Then
                    frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
                        & vbCrLf & "Device driver failed READ of sign-on bytes " _
                        & "for device: " & bCurDev _
                        & vbCrLf & "Check all cable connections and try again." _
                        & vbCrLf
                    fRetValMisc = ScrollText("down")
                    GoTo ENABLE_CONTROLS
                End If
                Dim dataString As String
                dataString = ""
                For i = 0 To 7
                    dataString = dataString & " 0x" & Hex(bHostClientDataBuf(i))
                Next i
                'For trouble-shooting only
                'frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
                '    & vbCrLf & "Values read after sending" & vbCrLf _
                '    & "      sign-on token with new rate: " & dataString & vbCrLf
                'fRetValMisc = ScrollText("down")
                
                
'=======================================================================
'=== Wait settling time for calibration ================================
'=======================================================================
                frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
                    & vbCrLf & "Rate sent. Waiting settling time"
                fRetValMisc = ScrollText("down")
                frmM301_VB.Timer1.Enabled = False
                frmM301_VB.Timer1.Interval = 3000
                fTimerStat = TIMER_START
                frmM301_VB.Timer1.Enabled = True
                While fTimerStat = TIMER_START
                    DoEvents
                Wend
                
                
'=======================================================================
'=== Get results from system calibration ===============================
'=======================================================================
                iNumBytesToReadWrite = 32
                ReDim bHostClientDataBuf(iNumBytesToReadWrite)
                
                fRetVal = DLL_ReadWriteOneDevice(DO_READ, bHostClientDataBuf(0), _
                        bCurDevAsIndex, iNumBytesToReadWrite, 0)
                If fRetVal = False Then
                    frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
                        & vbCrLf & "Device driver failed READ of mode registers " _
                        & "for device: " & bCurDev _
                        & vbCrLf & "Check all cable connections and try again." _
                        & vbCrLf
                    fRetValMisc = ScrollText("down")
                    GoTo ENABLE_CONTROLS
                End If
                dataString = ""
                For i = 0 To 7
                    dataString = dataString & " 0x" & Hex(bHostClientDataBuf(i))
                Next i
                'For trouble-shooting only
                'frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
                '    & vbCrLf & "Values read after sending rate change token: " & dataString & vbCrLf
                'fRetValMisc = ScrollText("down")
                
                
'=======================================================================
'=== Re-set rate variable in DLL to match that in application ==========
'=======================================================================
                DeviceObjectArray(bCurDevAsIndex).DEV_iRate _
                   = DeviceObjectArray_TEMP(bCurDevAsIndex).DEV_iRate
                fRetVal = DLL_SetRate(bCurDev, _
                    DeviceObjectArray(bCurDevAsIndex).DEV_iRate)
                If fRetVal = False Then
                    frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
                        & vbCrLf & "Failed to send rate to device" _
                        & vbCrLf & "Check all cable connections and try again." _
                        & vbCrLf
                    fRetValMisc = ScrollText("down")
                    GoTo ENABLE_CONTROLS
                End If
                bSetupFlags = bSetupFlags And (Not RATE_CHANGE)
            End If
            
            If bSetupFlags And RANGE_CHANGE Then
                'Nothing else to really do here. Just keep this marker
                ' in case it's needed later.
                bSetupFlags = bSetupFlags And (Not RANGE_CHANGE)
            End If
        End If
    End If
    
    If bSetupFlags And CHAN_CHANGE Then
        DeviceObjectArray(bCurDevAsIndex).DEV_bChan _
            = DeviceObjectArray_TEMP(bCurDevAsIndex).DEV_bChan
        frmM301_VB.EditChan.Text = DeviceObjectArray(bCurDevAsIndex).DEV_bChan
        strSetupChanText = DeviceObjectArray(bCurDevAsIndex).DEV_bChan
        bSetupFlags = bSetupFlags And (Not CHAN_CHANGE)
        If fSignOn Then
            bChanToSend = frmM301_VB.EditChan.Text
            fChanChangePending = True
            frmM301_VB.BtnSendChan.BackColor = &H5555FF
        End If
    End If
    
    frmM301_VB.txtMsgDisplay.Text = frmM301_VB.txtMsgDisplay.Text _
        & vbCrLf & "R E A D Y ---------------------" & vbCrLf
    fRetValMisc = ScrollText("down")

    'MsgBox "Unloading frmSetup", MSG_BOX_OK
ENABLE_CONTROLS:
    If fSignOn Then
        MainPnlCtrlEnable
    End If
Exit1:
End Sub
Private Sub BtnCancel_Click()
    bSetupFlags = NO_CHANGE
    Unload frmSetup
End Sub
Private Sub BtnSave_Click()
    Unload frmSetup
End Sub
'Private Sub ComboDeviceNum_Change()
'    ComboDeviceNum.Text = strSetupComboDeviceNum
'End Sub
'Private Sub ComboDeviceNum_Click()
'    'MsgBox "got the click", vbOK
'    strSetupComboDeviceNum = ComboDeviceNum.Text
    
'    ComboDeviceID.Text _
'        = Hex(DeviceObjectArray(bCurDevAsIndex).DEV_sID) & "h"
'    ComboRate.Text _
'            = DeviceObjectArray(bCurDevAsIndex).DEV_iRate & "Hz"
    
'    If DeviceObjectArray(frmSetup.ComboDeviceNum.Text).DEV_bRange = 0 Then
'        ComboRange.Text = "Bipolar"
'    Else
'        ComboRange.Text = "Unipolar"
'    End If
        
'    frmSetup.ComboRate.Text _
'            = DeviceObjectArray(bCurDevAsIndex).DEV_iRate & "Hz"
'End Sub
Private Sub ComboID_Change()
    ComboID.Text = strSetupIDText
    'MsgBox "got the change", MSG_BOX_OK
End Sub
Private Sub ComboID_Click()
    'strSetupIDText = ComboID.Text
    MsgBox "got the change: " & ComboID.Text, MSG_BOX_OK
    If bNumDevicesLocal > 0 Then
        For i = 0 To bNumDevicesLocal - 1
            If sLLABS_DeviceIDList(i) = ComboID.Text Then
                bCurDevAsIndex_TEMP = i
                GoTo DONE_FIND
            End If
        Next i
    End If

DONE_FIND:
    
    
'    DeviceObjectArray_TEMP(bCurDevAsIndex).DEV_sID _
'        = ComboID.Text
'    bCurDevAsIndex_TEMP
    bSetupFlags = bSetupFlags Or DEVICE_CHANGE
End Sub
Private Sub ComboChan_Change()
    'ComboChan.Text = strSetupChanText
    'MsgBox "got the change", MSG_BOX_OK
    ComboChan.Text = DeviceObjectArray(bCurDevAsIndex).DEV_bChan
End Sub
Private Sub ComboChan_Click()
    'DeviceObjectArray(bCurDevAsIndex).DEV_bChan = ComboChan.Text
    DeviceObjectArray_TEMP(bCurDevAsIndex).DEV_bChan = ComboChan.Text
    bSetupFlags = bSetupFlags Or CHAN_CHANGE
End Sub
Private Sub ComboRate_Change()
    ComboRate.Text = strSetupRateText
End Sub
Private Sub ComboRate_Click()
    'MsgBox DeviceObjectArray(bCurDevAsIndex).DEV_iRate, MSG_BOX_OK
    strSetupRateText = ComboRate.Text
    Dim val
    val = InStr(strSetupRateText, "H")
    'DeviceObjectArray(bCurDevAsIndex).DEV_iRate _
    '    = Mid$(strSetupRateText, 1, val - 1)
    DeviceObjectArray_TEMP(bCurDevAsIndex).DEV_iRate _
        = Mid$(strSetupRateText, 1, val - 1)
    bSetupFlags = bSetupFlags Or RATE_CHANGE
    'MsgBox DeviceObjectArray(bCurDevAsIndex).DEV_iRate, MSG_BOX_OK
End Sub
Private Sub ComboRange_Change()
    ComboRange.Text = strSetupRangeText
End Sub
Private Sub ComboRange_Click()
    'strSetupRangeText = ComboRange.Text
    If ComboRange.Text = "Bipolar" Then
       ' MsgBox "got unipolar", MSG_BOX_OK
        'DeviceObjectArray(bCurDevAsIndex).DEV_bRange = 128
        DeviceObjectArray_TEMP(bCurDevAsIndex).DEV_bRange = 128
    Else
        'MsgBox "got bipolar", MSG_BOX_OK
        'DeviceObjectArray(bCurDevAsIndex).DEV_bRange = 0
        DeviceObjectArray_TEMP(bCurDevAsIndex).DEV_bRange = 0
    End If
    
    'bSetupFlags = bSetupFlags Or RATE_CHANGE
End Sub
